## klibc 1.5.12

=== Makefile ===
SRCROOT = .

# kbuild compatibility
export srctree  := $(shell pwd)
export objtree  := $(shell pwd)
export KLIBCSRC := usr/klibc
export VERSION := $(shell cat $(KLIBCSRC)/version)
export KLIBCINC := usr/include
export KLIBCOBJ := usr/klibc
export KLIBCKERNELSRC := linux/
export KLIBCKERNELOBJ := linux/
include scripts/Kbuild.include

KLIBCROSS	?= $(CROSS_COMPILE)
export KLIBCROSS
export CC	:= $(KLIBCROSS)gcc
export LD	:= $(KLIBCROSS)ld
export AR	:= $(KLIBCROSS)ar
export RANLIB	:= $(KLIBCROSS)ranlib
export STRIP	:= $(KLIBCROSS)strip
export NM	:= $(KLIBCROSS)nm
export OBJCOPY  := $(KLIBCROSS)objcopy
export OBJDUMP  := $(KLIBCROSS)objdump

NOSTDINC_FLAGS := -nostdlib -nostdinc -isystem $(shell $(CC) -print-file-name=include)

ARCH	          := $(shell uname -m | sed -e s/i.86/i386/ -e s/parisc64/parisc/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/ -e s/sh4/sh/)
export KLIBCARCH  ?= $(ARCH)
export KLIBCARCHDIR := $(shell echo $(KLIBCARCH) | sed -e s/s390x/s390/)

export HOSTCC     := gcc
export HOSTCFLAGS := -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer
export PERL       := perl

# Location for installation
export prefix      = /usr
export bindir      = $(prefix)/bin
export libdir      = $(prefix)/lib
export mandir      = $(prefix)/man
export INSTALLDIR  = $(prefix)/lib/klibc
export INSTALLROOT =

# Create a fake .config as present in the kernel tree
# But if it exists leave it alone
$(if $(wildcard $(objtree)/.config),,$(shell cp defconfig .config))

# Prefix Make commands with $(Q) to silence them
# Use quiet_cmd_xxx, cmd_xxx to create nice output
# use make V=1 to get verbose output

ifdef V
  ifeq ("$(origin V)", "command line")
    KBUILD_VERBOSE = $(V)
  endif
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(MAKEFLAGS)),)
  quiet=silent_
endif

export quiet Q KBUILD_VERBOSE

# Do not print "Entering directory ..."
MAKEFLAGS += --no-print-directory

# Shorthand to call Kbuild.klibc
klibc := -f $(srctree)/scripts/Kbuild.klibc obj

# Very first target
.PHONY: all klcc klibc
all: klcc klibc

.config: defconfig linux
	@echo "defconfig has changed, please remove or edit .config"
	@false

linux:
	@echo "The 'linux' symlink is missing; it should point to a kernel tree "
	@echo "configured for the $(KLIBCARCH) architecture."
	@false

rpmbuild = $(shell which rpmbuild 2>/dev/null || which rpm)

klibc.spec: klibc.spec.in $(KLIBCSRC)/version
	sed -e 's/@@VERSION@@/$(VERSION)/g' < $< > $@

# Build klcc - it is the first target
klcc: .config
	$(Q)$(MAKE) $(klibc)=klcc

klibc: .config
	$(Q)$(MAKE) $(klibc)=.

test: klibc
	$(Q)$(MAKE) $(klibc)=usr/klibc/tests


###
# allow one to say make dir/file.o
# Caveat: works only for .c files where we have a Kbuild file in same dir
%.o: %.c FORCE
	 $(Q)$(MAKE) $(klibc)=$(dir $<) $(dir $<)$(notdir $@)

%.s: %.c FORCE
	 $(Q)$(MAKE) $(klibc)=$(dir $<) $(dir $<)$(notdir $@)

%.i: %.c FORCE
	 $(Q)$(MAKE) $(klibc)=$(dir $<) $(dir $<)$(notdir $@)

FORCE: ;
###
# clean: remove generated files
# mrproper does a full cleaning including .config and linux symlink
FIND_IGNORE := \( -name .git \) -prune -o
quiet_cmd_rmfiles = $(if $(wildcard $(rm-files)),RM     $(wildcard $(rm-files)))
      cmd_rmfiles = rm -f $(rm-files)
clean:
	$(Q)$(MAKE) -f $(srctree)/scripts/Makefile.clean obj=.
	$(Q)find . $(FIND_IGNORE) \
		\( -name *.o -o -name *.a -o -name '.*.cmd' -o \
		   -name '.*.d' -o -name '.*.tmp' \) \
		-type f -print | xargs rm -f

rm-files := .config linux
distclean mrproper: clean
	 $(Q)find . $(FIND_IGNORE) \
		\( -name '*.orig' -o -name '*.rej' -o -name '*~' \
		-o -name '*.bak' -o -name '#*#' -o -name '.*.orig' \
		-o -name '.*.rej' -o -size 0 \
		-o -name '*%' -o -name '.*.cmd' -o -name 'core' \) \
		-type f -print | xargs rm -f
	$(call cmd,rmfiles)

install: all
	$(Q)$(MAKE) -f $(srctree)/scripts/Kbuild.install obj=.

# This does all the prep work needed to turn a freshly exported git repository
# into a release tarball tree
release: klibc.spec
	rm -f maketar.sh .config

## klibc 1.5.14-1~exp1ubuntu2

=== debian/changelog ===
klibc (1.5.14-1~exp1ubuntu2) jaunty; urgency=low

  * 20_ext4.patch: Backport Theodore Ts'o's patch from 1.5.15 to fix
    ext4/ext4dev probing (LP: #309762).

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 08 Jan 2009 13:53:41 +0000

klibc (1.5.14-1~exp1ubuntu1) jaunty; urgency=low

  * Resynchronise with Debian (gcc unhardcoding fixes LP: #297152).
    Remaining changes:
    - Add lpia to the architecture list for klibc-utils-floppy-udeb.

 -- Colin Watson <cjwatson@ubuntu.com>  Sat, 22 Nov 2008 11:38:17 +0000

klibc (1.5.14-1~exp1) experimental; urgency=low

  * New upstream version
    - nuke merged 11_klibc-Default-signal-3-to-bsd_signal-3.patch
    - no longer hardcode gcc

 -- maximilian attems <maks@debian.org>  Mon, 11 Aug 2008 16:34:11 +0200

klibc (1.5.12-2ubuntu1) jaunty; urgency=low

  * Merge from debian unstable, remaining changes:
    - Add lpia to the architecture list for klibc-utils-floppy-udeb.

 -- Scott James Remnant <scott@ubuntu.com>  Tue, 11 Nov 2008 16:31:24 +0000

klibc (1.5.12-2) unstable; urgency=medium

  * Add backport 11_klibc-Default-signal-3-to-bsd_signal-3.patch.
  * Adjust watch file.

 -- maximilian attems <maks@debian.org>  Mon, 11 Aug 2008 16:09:45 +0200

klibc (1.5.12-1ubuntu1) intrepid; urgency=low

  * Merge from debian unstable, remaining changes:
    - Add lpia to the architecture list for klibc-utils-floppy-udeb.

 -- Kees Cook <kees@ubuntu.com>  Sun, 03 Aug 2008 19:06:02 -0700

klibc (1.5.12-1) unstable; urgency=low

  * New upstream release (memmove, fflush, cpio) (closes: #489945)

 -- maximilian attems <maks@debian.org>  Sat, 12 Jul 2008 21:48:56 +0200

klibc (1.5.11-3) unstable; urgency=high

  * libklibc-dev depend on gcc-4.1. (closes: #489103)

 -- maximilian attems <maks@debian.org>  Thu, 03 Jul 2008 19:33:56 +0200

klibc (1.5.11-2) unstable; urgency=high

  * gcc-4.1 build dep.

 -- maximilian attems <maks@debian.org>  Fri, 27 Jun 2008 01:40:39 +0200

klibc (1.5.11-1) unstable; urgency=high

  * New upstream release (ext4, ipconfig, mount)
    - drop merged 11-klibc-run-init-drop-executable-stack.patch,
      12-klibc-avoid-.gitignore-in-the-include-directory.patch
  * Fallback to gcc-4.1 4.3 miscompiles. (closes: #486557)

 -- maximilian attems <maks@debian.org>  Fri, 27 Jun 2008 00:59:27 +0200

klibc (1.5.10-1ubuntu1) intrepid; urgency=low

  * Merge from debian unstable, remaining changes:
    - Add lpia to the architecture list for klibc-utils-floppy-udeb.

 -- Kees Cook <kees@ubuntu.com>  Mon, 09 Jun 2008 10:40:21 -0700

klibc (1.5.10-1) unstable; urgency=low

  * New upstream release (dmesg, nfsmount)
    - dmesg: fix the stripping of priority codes (closes: #483186)
    - ubuntu sync rework 11-klibc-run-init-drop-executable-stack.patch
    - add git fix 12-klibc-avoid-.gitignore-in-the-include-directory.patch

 -- maximilian attems <maks@debian.org>  Fri, 27 Jun 2008 00:59:21 +0200

klibc (1.5.9-2) unstable; urgency=low

  * debian/control: Fix Description klibc-utils are not statically linked.
    Thanks Anthony Towns <ajt@debian.org> for noticing.
  * klibc-utils-floppy-udeb.install: Drop mkdir, mknod, sh due to full floppy.
    Thanks Joey Hess <joeyh@debian.org>. (closes: #474061)

 -- maximilian attems <maks@debian.org>  Wed, 09 Apr 2008 11:00:29 +0200

klibc (1.5.9-1) unstable; urgency=low

  * New upstream release (fstype jfs + nilfs2, ipconfig, nfsmount)
    - Drop merged 02_header_clean_install.patch, 20_mount-options.patch
    - mknod gained -m permission switch. (closes: #469577)
  * debian/control: Add git Vcs fields.

 -- maximilian attems <maks@debian.org>  Fri, 28 Mar 2008 23:09:57 +0100

klibc (1.5.8-1) unstable; urgency=low

  * New upstream release (fstype squashfs-lzma, ipconfig) (closes: #455703)
  * Ubuntu sync add 20_mount-options.patch for FUSE mount. (closes: #463258)
  * Add 02_header_clean_install.patch.
  * Drop unused 03-sparc-libgcc42.patch.
  * Add 10_insmod.patch for d-i floppy usage.
  * Fix copyright notice.
  * Newer standard version without changes.

 -- maximilian attems <maks@debian.org>  Sat, 22 Mar 2008 14:09:56 +0100

klibc (1.5.7-4ubuntu3) hardy; urgency=low

  * Adjust 30-drop-executable-stack.patch: sledgehammer run-init
    instead of the entire klibc suite, since PAE+nx and signal
    handlers could end up failing in rare cases.

 -- Kees Cook <kees@ubuntu.com>  Fri, 04 Apr 2008 17:39:58 -0700

klibc (1.5.7-4ubuntu2) hardy; urgency=low

  * Add 30-drop-executable-stack.patch: do not generate executable
    stack for ia32, so the READ_IMPLIES_EXEC does not get set for
    children (LP: #202161).

 -- Kees Cook <kees@ubuntu.com>  Thu, 03 Apr 2008 11:37:28 -0700

klibc (1.5.7-4ubuntu1) hardy; urgency=low

  * Resynchronise with Debian. Remaining changes:
    - Add lpia to the architecture list for klibc-utils-floppy-udeb.
    - 20_mount-options.patch: Add trivial support for the -f and -i options
      to mount and the -i option to umount. This should be enough to support
      mounting FUSE filesystems in the initramfs.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 10 Dec 2007 12:57:54 +0000

klibc (1.5.7-4) unstable; urgency=high

  * debian/rules: Set verbose kbuild for toolchain troubles.  Compile
    32 bit on ppc and 31 bit on s390. (closes: #453422, #453424)

 -- maximilian attems <maks@debian.org>  Fri,  7 Dec 2007 16:12:36 +0100

klibc (1.5.7-3) unstable; urgency=high

  * debian/rules: s/sparc64/sparc/ thanks to the Debian sparc folks.
    (closes: #399724)

 -- maximilian attems <maks@debian.org>  Thu, 22 Nov 2007 18:50:55 +0100

klibc (1.5.7-2) unstable; urgency=high

  * Add 03-sparc-libgcc42.patch (closes: #440721)
    Thanks for report and testing to Kilian Krause <kilian@debian.org>

 -- maximilian attems <maks@debian.org>  Thu, 22 Nov 2007 18:50:50 +0100

klibc (1.5.7-1) unstable; urgency=low

  * New upstream release
  * Build-dep on s/flex/m4/.

 -- maximilian attems <maks@debian.org>  Tue, 04 Sep 2007 13:03:09 +0200

klibc (1.5.6-2) unstable; urgency=high



=== debian/control ===
Source: klibc
Priority: optional
Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: maximilian attems <maks@debian.org>
Uploaders: Jeff Bailey <jbailey@raspberryginger.com>
Build-Depends: cdbs, debhelper (>= 5.0.0), linux-libc-dev, bison, m4
Section: libs
Standards-Version: 3.7.3
Vcs-Browser: http://git.debian.org/?p=kernel/klibc.git
Vcs-Git: git://git.debian.org/git/kernel/klibc.git

Package: libklibc-dev
Section: libdevel
Architecture: any
Depends: libklibc (= ${binary:Version})
Description: kernel headers used during the build of klibc
 This package contains the set of kernel headers that were required to
 build klibc and the utilities that ship with it.  This may or may
 not be a complete enough set to build other programs that link against
 klibc.  If in doubt, use real kernel headers instead.

Package: libklibc
Section: libs
Architecture: any
Description: minimal libc subset for use with initramfs
 klibc is intended to be a minimalistic libc subset for use with
 initramfs.  It is deliberately written for small size, minimal
 entanglement, and portability, not speed.  It is definitely a work in
 progress, and a lot of things are still missing.


Package: klibc-utils
Section: libs
Architecture: any
Depends: libklibc (= ${binary:Version})
Description: small utilities built with klibc for early boot
 This package contains a collection of programs that are linked
 against klibc. These duplicate some of the functionality of a
 regular Linux toolset, but are typically much smaller than their
 full-function counterparts.  They are intended for inclusion in
 initramfs images and embedded systems.

Package: klibc-utils-udeb
Section: debian-installer
Architecture: any
XC-Package-Type: udeb
Depends: libklibc-udeb (= ${binary:Version})
Description: small utilities built with klibc for early boot
 This package contains a collection of programs that are linked
 against klibc. These duplicate some of the functionality of a
 regular Linux toolset, but are typically much smaller than their
 full-function counterparts.  They are intended for inclusion in
 initramfs images and embedded systems.


Package: klibc-utils-floppy-udeb
Section: debian-installer
Architecture: alpha arm armeb armel amd64 hppa i386 lpia m68k mips mipsel powerpc s390 sparc
XC-Package-Type: udeb
Depends: libklibc-udeb (= ${binary:Version})
Description: small utilities built with klibc for the boot floppy
 This package contains a small collection of programs that are linked
 against klibc. These duplicate some of the functionality of a
 regular Linux toolset, but are typically much smaller than their
 full-function counterparts.  They are intended for inclusion in
 boot floppies.


Package: libklibc-udeb
Section: debian-installer
Architecture: any
XC-Package-Type: udeb
Description: minimal libc subset for use with initramfs
 klibc is intended to be a minimalistic libc subset for use with
 initramfs.  It is deliberately written for small size, minimal
 entanglement, and portability, not speed.  It is definitely a work in
 progress, and a lot of things are still missing.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/cdbs/1/class/makefile.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/simple-patchsys.mk

ifeq ($(DEB_ARCH),armel)
DEB_MAKE_ENVVARS := CONFIG_AEABI=y
endif
ifeq ($(DEB_ARCH),ia64)
DEB_MAKE_ENVVARS := ARCH=ia64
endif
ifeq ($(DEB_ARCH),sparc)
DEB_MAKE_ENVVARS := ARCH=sparc
endif
ifeq ($(DEB_ARCH),s390)
DEB_MAKE_ENVVARS := ARCH=s390
endif
ifeq ($(DEB_ARCH),powerpc)
ARCH=ppc
endif

DEB_MAKE_INVOKE := make
DEB_MAKE_CLEAN_TARGET := clean
DEB_MAKE_BUILD_TARGET := all
DEB_MAKE_ENVVARS := INSTALLROOT=debian/tmp $(DEB_MAKE_ENVVARS)

# Enable this to get verbose build information
DEB_MAKE_ENVVARS += KBUILD_VERBOSE=1

DEB_MAKE_INVOKE = make -C $(DEB_BUILDDIR) $(DEB_MAKE_ENVVARS)

DEB_MAKE_INSTALL_TARGET := install

DEB_FIXPERMS_EXCLUDE := klibc-

pre-build::
	if [ ! -e linux ]; then \
		rm -rf linux/include; \
		mkdir -p linux/include; \
		ln -s /usr/include/linux linux/include; \
		for x in /usr/include/asm*; do \
			ln -s $${x} linux/include; \
		done \
	fi

clean::
	rm -rf linux
	make $(DEB_MAKE_ENVVARS) mrproper

#common-build-arch::
#	if [ -e ash/sh.shared ]; then mv -f ash/sh.shared ash/sh; fi

=== debian/watch ===
version=3
http://www.kernel.org/pub/linux/libs/klibc/Testing/klibc-([0-9].[0-9].[0-9]+).tar.bz2

## klibc 1.5.17

=== debian/changelog ===
klibc (1.5.17-4ubuntu1) lucid; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - Recognise ext4 filesystems without journals.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 23 Mar 2010 10:34:57 +0000

klibc (1.5.17-4) unstable; urgency=medium

  * libklibc-dev: On preinst remove old include dirs that hinder
    shipped symlinks to linux-libc-dev. (closes: #574854)

 -- maximilian attems <maks@debian.org>  Sun, 21 Mar 2010 22:51:11 +0100

klibc (1.5.17-3) unstable; urgency=low

  * Override dh_auto_test to pass DEB_HOST_ARCH on make test. (closes: #574746)

 -- maximilian attems <maks@debian.org>  Sat, 20 Mar 2010 20:52:09 +0100

klibc (1.5.17-2) unstable; urgency=low

  * Set DEB_HOST_ARCH using dpkg-architecture. (closes: #574740)

 -- maximilian attems <maks@debian.org>  Sat, 20 Mar 2010 18:24:16 +0100

klibc (1.5.17-1) unstable; urgency=low

  [ Jan Hauke Rahm ]
  * Switch from cdbs to debhelper 7
  * Switch to Source Format 3.0 (quilt) (closes: #573908)
  * Make documentation of klibc-utils and libklibc-dev be a symlink to
    libklibc

  [ maximilian attems ]
  * New upstream release
    - Fix FTFBS i386/sparc. (closes: #573926)
    - sparc, sparc64 use sys_socketcall unconditionally. (closes: #444087)
    - ipconfig may discard useful packets. (closes: #511959)

 -- maximilian attems <maks@debian.org>  Sat, 20 Mar 2010 02:11:20 +0100

klibc (1.5.16-1) unstable; urgency=low

  [ maximilian attems ]
  * New upstream release
    - ipconfig: raise field length for rootpath DHCP option.
      (closes: #497800)
    - ipconfig: send requested hostname in DHCP discover/request.
      (closes: #367301)
    - ipconfig: set null ciaddr on DHCPREQUEST during SELECTING state.
      (closes: #497879)
    - mount: list fs all mounted fs, support -t switch for one fs.
      (closes: #491067)
    - refresh 10_insmod.patch.
    - readlink be silent on failure. (closes: #565224)
    - fix compilation against up to 2.6.33 linux-libc-dev. (closes: #552825)
  * watch file fixup for new upstream directories.
  * Pump standard version to 3.8.4 without changes.
  * Add lintian overrides for embedded-zlib needed for early userspace.

  [ Nobuhiro Iwamatsu ]
  * klibc: add support Renesas SH(sh4) (closes: #540126)

  [ Ben Hutchings ]
  * Fix klibc Debian specific build with 02-klibc_linux_libc_dev.patch.
  * Add libklibc-dev depends on linux-libc-dev.

 -- maximilian attems <maks@debian.org>  Sun, 14 Mar 2010 22:46:21 +0100

klibc (1.5.15-1ubuntu4) lucid; urgency=low

  * 23-use-AF_INET-directly.patch,
    24-add-relevant-socket-h-definitions.patch: Backport patches sent
    upstream by Debian maintainer to add some <linux/socket.h> definitions
    (LP: #534281).

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 10 Mar 2010 18:37:51 +0000

klibc (1.5.15-1ubuntu3) lucid; urgency=low

  * rebuild rest of main for armel armv7/thumb2 optimization;
    UbuntuSpec:mobile-lucid-arm-gcc-v7-thumb2

 -- Alexander Sack <asac@ubuntu.com>  Sat, 06 Mar 2010 13:29:50 +0100

klibc (1.5.15-1ubuntu2) karmic; urgency=low

  * 20-signal-cleanup.patch (update): Stop redefining 'struct sigaction' on
    sparc.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 05 Oct 2009 09:38:00 +0100

klibc (1.5.15-1ubuntu1) karmic; urgency=low

  * 20-signal-cleanup.patch: Cope with header changes in Linux 2.6.30.
  * 21-mntproc-definitions.patch: MNTPROC_MNT and MNTPROC_UMNT are no longer
    defined by the kernel. Hack around this by restoring the old
    definitions.
  * 22-ext4-no-journal.patch: Recognise ext4 filesystems without journals
    (LP: #416636).

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 04 Oct 2009 23:10:12 +0100

klibc (1.5.15-1) unstable; urgency=low

  [ maximilian attems ]
  * New upstream release:
    - fstype ext4 support. (closes: #510758)
    - chroot cmd fixed. (closes: #494829)
  * Pump standard version to 3.8.0 without changes.
  * Drop arm of the klibc-utils-floppy-udeb arch list.
  * Fix debhelper-but-no-misc-depends.
  * debian/copyright refer to GPL v2.
  * debian/rules nuke old commented unused lines.

  [ Colin Watson ]
  * Add lpia to the architecture list for klibc-utils-floppy-udeb.
    (closes: #506427)

  [ Thiemo Seufer ]
  * Fix FTBFS on MIPS64 kernel. (closes: #496175)

 -- maximilian attems <maks@debian.org>  Mon, 16 Feb 2009 16:41:51 +0100

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,18 @@
 Source: klibc
 Priority: optional
-Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: maximilian attems <maks@debian.org>
 Uploaders: Jeff Bailey <jbailey@raspberryginger.com>
-Build-Depends: cdbs, debhelper (>= 5.0.0), linux-libc-dev, bison, m4
+Build-Depends: debhelper (>= 7.0.50), linux-libc-dev, bison, m4
 Section: libs
-Standards-Version: 3.7.3
+Standards-Version: 3.8.4
 Vcs-Browser: http://git.debian.org/?p=kernel/klibc.git
 Vcs-Git: git://git.debian.org/git/kernel/klibc.git
 
 Package: libklibc-dev
 Section: libdevel
 Architecture: any
-Depends: libklibc (= ${binary:Version})
+Depends: libklibc (= ${binary:Version}), linux-libc-dev, ${misc:Depends}
 Description: kernel headers used during the build of klibc
  This package contains the set of kernel headers that were required to
  build klibc and the utilities that ship with it.  This may or may
@@ -22,6 +22,7 @@
 Package: libklibc
 Section: libs
 Architecture: any
+Depends: ${misc:Depends}
 Description: minimal libc subset for use with initramfs
  klibc is intended to be a minimalistic libc subset for use with
  initramfs.  It is deliberately written for small size, minimal
@@ -32,7 +33,7 @@
 Package: klibc-utils
 Section: libs
 Architecture: any
-Depends: libklibc (= ${binary:Version})
+Depends: libklibc (= ${binary:Version}), ${misc:Depends}
 Description: small utilities built with klibc for early boot
  This package contains a collection of programs that are linked
  against klibc. These duplicate some of the functionality of a
@@ -55,7 +56,7 @@
 
 Package: klibc-utils-floppy-udeb
 Section: debian-installer
-Architecture: alpha arm armeb armel amd64 hppa i386 lpia m68k mips mipsel powerpc s390 sparc
+Architecture: alpha armeb armel amd64 hppa i386 lpia m68k mips mipsel powerpc s390 sparc
 XC-Package-Type: udeb
 Depends: libklibc-udeb (= ${binary:Version})
 Description: small utilities built with klibc for the boot floppy

## klibc 1.5.20

=== Makefile ===
--- 
+++ 
@@ -1,15 +1,21 @@
 SRCROOT = .
+
+# *DOCUMENTATION*
+# To see a list of typical targets execute "make help"
 
 # kbuild compatibility
 export srctree  := $(shell pwd)
 export objtree  := $(shell pwd)
 export KLIBCSRC := usr/klibc
-export VERSION := $(shell cat $(KLIBCSRC)/version)
+export VERSION := $(shell cat $(srctree)/$(KLIBCSRC)/version)
 export KLIBCINC := usr/include
 export KLIBCOBJ := usr/klibc
-export KLIBCKERNELSRC := linux/
-export KLIBCKERNELOBJ := linux/
-include scripts/Kbuild.include
+export KLIBCKERNELSRC ?= linux
+export KLIBCKERNELOBJ ?= $(KLIBCKERNELSRC)
+
+export VPATH := $(srctree)
+
+include $(srctree)/scripts/Kbuild.include
 
 KLIBCROSS	?= $(CROSS_COMPILE)
 export KLIBCROSS
@@ -24,7 +30,7 @@
 
 NOSTDINC_FLAGS := -nostdlib -nostdinc -isystem $(shell $(CC) -print-file-name=include)
 
-ARCH	          := $(shell uname -m | sed -e s/i.86/i386/ -e s/parisc64/parisc/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/ -e s/sh4/sh/)
+ARCH	          := $(shell uname -m | sed -e s/i.86/i386/ -e s/parisc64/parisc/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/ -e s/sh.*/sh/)
 export KLIBCARCH  ?= $(ARCH)
 export KLIBCARCHDIR := $(shell echo $(KLIBCARCH) | sed -e s/s390x/s390/)
 
@@ -42,7 +48,8 @@
 
 # Create a fake .config as present in the kernel tree
 # But if it exists leave it alone
-$(if $(wildcard $(objtree)/.config),,$(shell cp defconfig .config))
+$(if $(wildcard $(objtree)/.config),,\
+  $(shell cp $(srctree)/defconfig $(objtree)/.config))
 
 # Prefix Make commands with $(Q) to silence them
 # Use quiet_cmd_xxx, cmd_xxx to create nice output
@@ -84,13 +91,15 @@
 .PHONY: all klcc klibc
 all: klcc klibc
 
-.config: defconfig linux
+$(objtree)/.config: $(srctree)/defconfig $(KLIBCKERNELOBJ)
 	@echo "defconfig has changed, please remove or edit .config"
 	@false
 
-linux:
-	@echo "The 'linux' symlink is missing; it should point to a kernel tree "
-	@echo "configured for the $(KLIBCARCH) architecture."
+$(KLIBCKERNELSRC):
+	@echo "Cannot find kernel sources."
+	@echo "Either make a 'linux' symlink point to a kernel tree "
+	@echo "configured for the $(KLIBCARCH) architecture or specify "
+	@echo "KLIBCKERNELSRC=<path> to the build."
 	@false
 
 rpmbuild = $(shell which rpmbuild 2>/dev/null || which rpm)
@@ -99,15 +108,34 @@
 	sed -e 's/@@VERSION@@/$(VERSION)/g' < $< > $@
 
 # Build klcc - it is the first target
-klcc: .config
+klcc: $(objtree)/.config
 	$(Q)$(MAKE) $(klibc)=klcc
 
-klibc: .config
+klibc: $(objtree)/.config
 	$(Q)$(MAKE) $(klibc)=.
 
 test: klibc
 	$(Q)$(MAKE) $(klibc)=usr/klibc/tests
 
+help:
+	@echo	'Cleaning targets:'
+	@echo	'  clean	- Remove most generated files'
+	@echo	'  mrproper	- Remove all generated files + config'
+	@echo	'  distclean	- mprproper + editor backup + patch files'
+	@echo	''
+	@echo	'Build targets:'
+	@echo	'all		- Build all targets'
+	@echo	'install	- Install klibc'
+	@echo	'klcc		- Wrapper around gcc to compile against klibc'
+	@echo	'test		- Run klibc tests'
+	@echo
+	@echo	'Build options:'
+	@echo	'KLIBCKERNELSRC - Path to a configured linux-2.6 tree'
+	@echo	'KLIBCKERNELOBJ - Path to kernel output dir (defaults to KLIBCKERNELSRC)'
+	@echo	'make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
+	@echo
+	@echo	'Sample invocation:'
+	@echo	'make  KLIBCKERNELSRC=`pwd`/../linux-2.6'
 
 ###
 # allow one to say make dir/file.o
@@ -135,7 +163,7 @@
 		   -name '.*.d' -o -name '.*.tmp' \) \
 		-type f -print | xargs rm -f
 
-rm-files := .config linux
+rm-files := $(objtree)/.config linux
 distclean mrproper: clean
 	 $(Q)find . $(FIND_IGNORE) \
 		\( -name '*.orig' -o -name '*.rej' -o -name '*~' \

=== debian/changelog ===
klibc (1.5.20-1ubuntu6) natty; urgency=low

  * debian/patches/multiarch-include-path: Include the multiarch include
    directory in klcc's path.  This fixes a build failure with rootskel
    against the current linux-libc-dev.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 14 Apr 2011 12:17:13 -0700

klibc (1.5.20-1ubuntu5) natty; urgency=low

  [ Wookey ]
  * Fix build to work with multiarched linux-libc-dev; LP: #750585.

  [ Steve Langasek ]
  * Tweak patch to behave correctly for both multiarch and pre-multiarch
    linux-libc-dev packages.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Apr 2011 02:27:17 -0700

klibc (1.5.20-1ubuntu4) natty; urgency=low

  * New patch, arm-size-directives, fixes generation of .size directive for
    ARM; this wouldn't build with recent binutils and was generating broken
    assembler anyway.

 -- Loïc Minier <loic.minier@linaro.org>  Wed, 16 Mar 2011 22:51:32 +0100

klibc (1.5.20-1ubuntu3) natty; urgency=low

  * usr/klibc/arch/ppc64/crt0.S: Fix build failure with stricter
    as (Colin Watson).

 -- Matthias Klose <doko@ubuntu.com>  Wed, 16 Mar 2011 21:10:30 +0100

klibc (1.5.20-1ubuntu2) natty; urgency=low

  * debian/patches/arm-thumb2: fix up ARM assembly to use 'bx lr' in place
    of 'mov pc, lr'.  LP: #527720.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 19 Feb 2011 22:54:19 -0800

klibc (1.5.20-1ubuntu1) natty; urgency=low

  * Install static binaries on ppc64.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 18 Feb 2011 13:37:56 +0000

klibc (1.5.20-1) unstable; urgency=high

  * New upstream release
    - ipconfig: fix infinite loop. (closes: #552554)
    - ipconfig: fix multiple dns domains. (closes: #594208)
  * klibc-utils.postinst: Nuke non empty dirs too. (closes: #594651)

 -- maximilian attems <maks@debian.org>  Sat, 28 Aug 2010 12:23:51 +0200

klibc (1.5.19-1) unstable; urgency=high

  * New upstream release
   - resume: silence warning on resume try. (closes: #586006)
   - sh4: syscalls fixes. (closes: #578076)
  * Fix doc symlinks on upgrade. (closes: #588763)
    Thanks Sven Joachim <svenjoac@gmx.de>.
  * Pump standard version to 3.9.1 without changes.

 -- maximilian attems <maks@debian.org>  Wed, 25 Aug 2010 13:07:03 +0200

klibc (1.5.18-1) unstable; urgency=medium

  * New upstream release (dash 0.5.6)
    - fstype btrfs (closes: #548047), ext4 !journal (closes: #536592)
    - sh4 build fix (closes: #574834)
    - shipp renamed README.ipconfig (closes: #478589)

 -- maximilian attems <maks@debian.org>  Thu, 22 Apr 2010 03:38:55 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Jeff Bailey <jbailey@raspberryginger.com>
 Build-Depends: debhelper (>= 7.0.50), linux-libc-dev, bison, m4
 Section: libs
-Standards-Version: 3.8.4
+Standards-Version: 3.9.1
 Vcs-Browser: http://git.debian.org/?p=kernel/klibc.git
 Vcs-Git: git://git.debian.org/git/kernel/klibc.git

=== debian/rules ===
#!/usr/bin/make -f

# let debhelper be verbose
#export DH_VERBOSE=1

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifeq ($(DEB_HOST_ARCH),armel)
DEB_MAKE_ENVVARS := CONFIG_AEABI=y
endif
ifeq ($(DEB_HOST_ARCH),ia64)
DEB_MAKE_ENVVARS := ARCH=ia64
endif
ifeq ($(DEB_HOST_ARCH),sparc)
DEB_MAKE_ENVVARS := ARCH=sparc
endif
ifeq ($(DEB_HOST_ARCH),s390)
DEB_MAKE_ENVVARS := ARCH=s390
endif
ifeq ($(DEB_HOST_ARCH),powerpc)
ARCH=ppc
endif
ifneq (,$(findstring $(DEB_HOST_ARCH),mips mipsel))
DEB_MAKE_ENVVARS := ARCH=mips
endif
ifeq ($(DEB_HOST_ARCH),sh4)
DEB_MAKE_ENVVARS := ARCH=sh
endif
ifeq ($(DEB_HOST_ARCH),ppc64)
DEB_MAKE_ENVVARS := ARCH=ppc64
endif

DEB_MAKE_ENVVARS := INSTALLROOT=debian/tmp $(DEB_MAKE_ENVVARS)

# Enable this to get verbose build information
DEB_MAKE_ENVVARS += KBUILD_VERBOSE=1

%:
	dh $@ --link-doc=libklibc

override_dh_auto_build:
	if [ ! -e linux ]; then \
		rm -rf linux/include; \
		mkdir -p linux/include; \
		ln -s /usr/include/linux linux/include; \
		if [ -n "$(DEB_HOST_MULTIARCH)" ]; then \
			ln -s /usr/include/$(DEB_HOST_MULTIARCH)/asm linux/include; \
		fi; \
		for x in /usr/include/asm*; do \
			ln -s $${x} linux/include; \
		done \
	fi
	make all $(DEB_MAKE_ENVVARS)

override_dh_auto_clean:
	rm -rf linux
	dh_auto_clean

override_dh_auto_install:
	make install $(DEB_MAKE_ENVVARS)

override_dh_auto_test:
	make test $(DEB_MAKE_ENVVARS)

override_dh_fixperms:
	dh_fixperms -Xklibc-

## klibc 1.5.22

=== debian/changelog ===
klibc (1.5.22-1ubuntu2) oneiric; urgency=low

  * Install /usr/lib/klibc/include/asm symlink even in the presence of
    multiarch libc6-dev (LP: #829356).

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 22 Aug 2011 12:32:52 +0100

klibc (1.5.22-1ubuntu1) oneiric; urgency=low

  * Restore change from 1.5.20-1ubuntu5, removed by mistake:
    - Fix build to work with multiarched linux-libc-dev.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 04 Jul 2011 17:21:55 +0100

klibc (1.5.22-1) unstable; urgency=high

  * New upstream release (arm, ipconfig)
    - arm: fix build failure with latest binutils. (closes: #618616)
    - arm: use bx on thumb2 (v3) (LP: #527720)
    - ipconfig: handle multiple connected network dev. (closes: #621065)
  * Ubuntu sync add ppc64-static. (closes: #613955)
    Thanks Colin Watson <cjwatson@ubuntu.com>.
  * Ubuntu sync add klcc multiarch-include-path. (closes: #622814)
    Thanks Steve Langasek <steve.langasek@canonical.com>
  * Pump standard version to 3.9.2 without changes.
  * Drop Jeff Bailey from Uploaders.

 -- maximilian attems <maks@debian.org>  Wed, 18 May 2011 13:39:01 +0200

klibc (1.5.21-1) unstable; urgency=low

  * New upstream release (i386 signal(), make 3.82, cleanups)

 -- maximilian attems <maks@debian.org>  Tue, 25 Jan 2011 23:45:20 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,9 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: maximilian attems <maks@debian.org>
-Uploaders: Jeff Bailey <jbailey@raspberryginger.com>
 Build-Depends: debhelper (>= 7.0.50), linux-libc-dev, bison, m4
 Section: libs
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Vcs-Browser: http://git.debian.org/?p=kernel/klibc.git
 Vcs-Git: git://git.debian.org/git/kernel/klibc.git

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 #export DH_VERBOSE=1
 
 DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
-DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 ifeq ($(DEB_HOST_ARCH),armel)
 DEB_MAKE_ENVVARS := CONFIG_AEABI=y

## klibc 1.5.25

=== debian/changelog ===
klibc (1.5.25-1) unstable; urgency=low

  * New upstream release (scandir, capset, capget, kinit drop_capabilities)

 -- maximilian attems <maks@debian.org>  Tue, 23 Aug 2011 17:54:43 +0200

klibc (1.5.24-1) unstable; urgency=low

  * New upstream release (sched_setaffinity, sched_getaffinity, kexec_load)
    - ipconfig: Don't try to guess the nameserver. (closes: #594638)
    - refresh debian/patches/klibc-linux-libc-dev

 -- maximilian attems <maks@debian.org>  Wed, 27 Jul 2011 16:54:47 +0200

klibc (1.5.23-2) unstable; urgency=low

  * Really apply Fix-minimal-mv-to-work-across-fs.

 -- maximilian attems <maks@debian.org>  Fri, 08 Jul 2011 01:09:48 +0200

klibc (1.5.23-1) unstable; urgency=low

  * New upstream release (arm, dash sync, limits.h, ppc64)
    - minimal mv in klibc-utils.
    - refresh debian/patches/insmod
  * Add Fix-minimal-mv-to-work-across-fs.patch (closes: #627808)
  * Add armhf support. (closes: #627252)
    Thanks to Konstantinos Margaritis <markos@genesi-usa.com>.
  * Add klibc crosscompile support. (closes: #629934)
    Thanks to Steve McIntyre <steve.mcintyre@linaro.org>.
  * debian/copyright: Add specific BSD license text to keep lintian happy.

 -- maximilian attems <maks@debian.org>  Tue, 14 Jun 2011 17:32:53 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: klibc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: maximilian attems <maks@debian.org>
+Maintainer: maximilian attems <maks@debian.org>
 Build-Depends: debhelper (>= 7.0.50), linux-libc-dev, bison, m4
 Section: libs
 Standards-Version: 3.9.2

=== debian/rules ===
--- 
+++ 
@@ -4,10 +4,13 @@
 #export DH_VERBOSE=1
 
 DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
-export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 ifeq ($(DEB_HOST_ARCH),armel)
 DEB_MAKE_ENVVARS := CONFIG_AEABI=y
+endif
+ifeq ($(DEB_HOST_ARCH),armhf)
+DEB_MAKE_ENVVARS := ARCH=arm CONFIG_AEABI=y CPU_ARCH=armv7-a CPU_TUNE=cortex-a8
 endif
 ifeq ($(DEB_HOST_ARCH),ia64)
 DEB_MAKE_ENVVARS := ARCH=ia64
@@ -33,6 +36,13 @@
 
 DEB_MAKE_ENVVARS := INSTALLROOT=debian/tmp $(DEB_MAKE_ENVVARS)
 
+DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+DEB_HOST_GNU_TYPE  := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
+ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
+    DEB_MAKE_ENVVARS += CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)-
+endif
+
+
 # Enable this to get verbose build information
 DEB_MAKE_ENVVARS += KBUILD_VERBOSE=1
 
@@ -44,11 +54,15 @@
 		rm -rf linux/include; \
 		mkdir -p linux/include; \
 		ln -s /usr/include/linux linux/include; \
+		INC_PATH="/usr/include/asm*"; \
 		if [ -n "$(DEB_HOST_MULTIARCH)" ]; then \
-			ln -s /usr/include/$(DEB_HOST_MULTIARCH)/asm linux/include; \
+			INC_PATH="$${INC_PATH} /usr/include/$(DEB_HOST_MULTIARCH)/asm*"; \
+			INC_PATH="$${INC_PATH} /usr/$(DEB_HOST_MULTIARCH)/include/asm*"; \
 		fi; \
-		for x in /usr/include/asm*; do \
-			ln -s $${x} linux/include; \
+		for x in $${INC_PATH}; do \
+			if [ -e $${x} ] ; then \
+				ln -sf $${x} linux/include; \
+			fi; \
 		done \
 	fi
 	make all $(DEB_MAKE_ENVVARS)

=== debian/watch ===
version=3
http://www.kernel.org/pub/linux/libs/klibc/Current/klibc-([0-9].[0-9].[0-9]+).tar.bz2

## klibc 2.0~rc1

=== debian/changelog ===
klibc (2.0~rc1-1experimental1) experimental; urgency=low

  * New upstream snapshot release (buffered stdio)
  * Ubuntu sync fix klcc for multiarch. (closes: #639057, LP: #829356)
    Thanks Colin Watson <cjwatson@ubuntu.com>.

 -- maximilian attems <maks@debian.org>  Tue, 06 Sep 2011 17:57:54 +0200

## klibc 2.0~rc3

=== Makefile ===
--- 
+++ 
@@ -91,7 +91,7 @@
 .PHONY: all klcc klibc
 all: klcc klibc
 
-$(objtree)/.config: $(srctree)/defconfig $(KLIBCKERNELOBJ)
+$(objtree)/.config: $(srctree)/defconfig
 	@echo "defconfig has changed, please remove or edit .config"
 	@false
 
@@ -130,12 +130,12 @@
 	@echo	'test		- Run klibc tests'
 	@echo
 	@echo	'Build options:'
-	@echo	'KLIBCKERNELSRC - Path to a configured linux-2.6 tree'
+	@echo	'KLIBCKERNELSRC - Path to a configured linux tree'
 	@echo	'KLIBCKERNELOBJ - Path to kernel output dir (defaults to KLIBCKERNELSRC)'
 	@echo	'make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
 	@echo
 	@echo	'Sample invocation:'
-	@echo	'make  KLIBCKERNELSRC=`pwd`/../linux-2.6'
+	@echo	'make  KLIBCKERNELSRC=`pwd`/../linux'
 
 ###
 # allow one to say make dir/file.o

## klibc 2.0.1

=== debian/changelog ===
klibc (2.0.1-3.1) unstable; urgency=low

  * Non-maintainer upload with consent of maintainer.
  * Add migration script for /usr/share/doc/libklibc-dev (Closes: #692951)

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 11 Nov 2012 11:30:14 +0000

klibc (2.0.1-3) unstable; urgency=medium

  [ Bill Pringlemeir ]
  * [f05ff11] [klibc] fix ARM longjmp with zero 'val'.

 -- maximilian attems <maks@debian.org>  Mon, 08 Oct 2012 21:57:01 +0200

klibc (2.0.1-2) unstable; urgency=low

  [ Sven Joachim ]
  * [08c03cf] klibc: produces 64-bit binaries on i386 with x86_64 kernel
    (Closes: #677087)

  [ Thorsten Glaser ]
  * [d8eae3a] [klibc] arm: fix trashing of callee-saved registers in thumb
     setjmp() (Closes: #634890)
  * [81170b5] [klibc] arm: unbreak armhf shared binaries (those with thumb)
  * [aeb7847] armhf builds are always thumb

  [ Jim Meyering ]
  * [9ba90cd] [klibc] Avoid overflow for very long variable name

 -- maximilian attems <maks@debian.org>  Mon, 01 Oct 2012 15:54:05 +0200

klibc (2.0.1-1) unstable; urgency=high

  * New upstream release (nfsmount, get{host,domain}name())
  * debian/watch: fix file for new repo layout.

 -- maximilian attems <maks@debian.org>  Thu, 28 Jun 2012 18:29:48 +0200

klibc (2.0-2) unstable; urgency=low

  * debian/control: Add breaks to initramfs-tools for ipconfig /run switch.

 -- maximilian attems <maks@debian.org>  Thu, 31 May 2012 15:42:03 +0200

klibc (2.0-1) unstable; urgency=low

  * New upstream release (arch, ipconfig)
    - ipconfig support domain-search, lease (closes: #627166)

 -- maximilian attems <maks@debian.org>  Thu, 31 May 2012 15:05:55 +0200

klibc (2.0~rc5-1) unstable; urgency=low

  * New upstream snapshot (arch fixes) (closes: #673413)

 -- maximilian attems <maks@debian.org>  Fri, 18 May 2012 18:16:51 +0200

klibc (2.0~rc4-1) unstable; urgency=low

  * New upstream snapshot (stdio work)
    - drop merged m68k-support
  * armel: Set arm arch for cross compiling.
  * klibc-linux-libc-dev: Adapt for cross building (closes: #666389)
    Based on Marcin Juszkiewicz <marcin.juszkiewicz@linaro.org> 

 -- maximilian attems <maks@debian.org>  Fri, 18 May 2012 14:48:04 +0200

klibc (2.0~rc3-1) unstable; urgency=low

  * New upstream snapshot (closes: #653790)
    - klibc/s390x klcc fix thanks to Aurelien Jarno <aurel32@debian.org>.
  * Pump standard version to 3.9.3 without changes.

 -- maximilian attems <maks@debian.org>  Fri, 02 Mar 2012 11:08:51 +0100

klibc (2.0~rc2-0.1) unstable; urgency=low

  * Non-maintainer upload with consent of maintainer.
  * Upload to unstable (maks says we target 2.0 for wheezy)
  * New upstream snapshot (fixes FTBFS)
  * Update Vcs-* for (temporary) move to collab-maint
  * Refresh all patches
  * Add m68k patch submitted upstream, for testing (Closes: #334917)
  * Shut up lintian

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 11 Feb 2012 19:25:23 +0000

klibc (1.5.25-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix build to work with multiarched linux-libc-dev (using patch from
    Ubuntu), closes: #645738.

 -- Julien Cristau <jcristau@debian.org>  Fri, 30 Dec 2011 17:04:30 +0100

=== debian/rules ===
--- 
+++ 
@@ -4,16 +4,19 @@
 #export DH_VERBOSE=1
 
 DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
-DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 ifeq ($(DEB_HOST_ARCH),armel)
-DEB_MAKE_ENVVARS := CONFIG_AEABI=y
+DEB_MAKE_ENVVARS := ARCH=arm CONFIG_AEABI=y
 endif
 ifeq ($(DEB_HOST_ARCH),armhf)
-DEB_MAKE_ENVVARS := ARCH=arm CONFIG_AEABI=y CPU_ARCH=armv7-a CPU_TUNE=cortex-a8
+DEB_MAKE_ENVVARS := ARCH=arm CONFIG_AEABI=y CPU_ARCH=armv7-a CPU_TUNE=cortex-a8 CONFIG_KLIBC_THUMB=y
 endif
 ifeq ($(DEB_HOST_ARCH),ia64)
 DEB_MAKE_ENVVARS := ARCH=ia64
+endif
+ifeq ($(DEB_HOST_ARCH),i386)
+DEB_MAKE_ENVVARS := ARCH=i386
 endif
 ifeq ($(DEB_HOST_ARCH),sparc)
 DEB_MAKE_ENVVARS := ARCH=sparc

## klibc 2.0.2

=== debian/changelog ===
klibc (2.0.2-1) unstable; urgency=low

  * New upstream release (dash, arm)
    - drop merged patches
    - build fixes for Linux > 3.4 (closes: #702068)

 -- maximilian attems <maks@debian.org>  Mon, 19 Aug 2013 22:59:22 +0200

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,11 @@
 Maintainer: maximilian attems <maks@debian.org>
 Build-Depends: debhelper (>= 7.0.50), linux-libc-dev, bison, m4
 Section: libs
-Standards-Version: 3.9.2
-Vcs-Browser: http://git.debian.org/?p=kernel/klibc.git
-Vcs-Git: git://git.debian.org/git/kernel/klibc.git
+Standards-Version: 3.9.4
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=kernel/klibc.git
+Vcs-Git: git://anonscm.debian.org/kernel/klibc.git
+# maybe some day replace with a real one?
+Homepage: http://git.kernel.org/?p=libs/klibc/klibc.git;a=summary
 
 Package: libklibc-dev
 Section: libdevel
@@ -18,7 +20,6 @@
  klibc.  If in doubt, use real kernel headers instead.
 
 Package: libklibc
-Section: libs
 Architecture: any
 Depends: ${misc:Depends}
 Description: minimal libc subset for use with initramfs
@@ -27,11 +28,10 @@
  entanglement, and portability, not speed.  It is definitely a work in
  progress, and a lot of things are still missing.
 
-
 Package: klibc-utils
-Section: libs
 Architecture: any
 Depends: libklibc (= ${binary:Version}), ${misc:Depends}
+Breaks: initramfs-tools (<< 0.103)
 Description: small utilities built with klibc for early boot
  This package contains a collection of programs that are linked
  against klibc. These duplicate some of the functionality of a
@@ -42,21 +42,22 @@
 Package: klibc-utils-udeb
 Section: debian-installer
 Architecture: any
-XC-Package-Type: udeb
-Depends: libklibc-udeb (= ${binary:Version})
-Description: small utilities built with klibc for early boot
+Package-Type: udeb
+Depends: libklibc-udeb (= ${binary:Version}), ${misc:Depends}
+Description: small utilities built with klibc for early boot (d-i)
  This package contains a collection of programs that are linked
  against klibc. These duplicate some of the functionality of a
  regular Linux toolset, but are typically much smaller than their
  full-function counterparts.  They are intended for inclusion in
  initramfs images and embedded systems.
-
+ .
+ This is the package for the Debian Installer.
 
 Package: klibc-utils-floppy-udeb
 Section: debian-installer
 Architecture: alpha armeb armel amd64 hppa i386 lpia m68k mips mipsel powerpc s390 sparc
-XC-Package-Type: udeb
-Depends: libklibc-udeb (= ${binary:Version})
+Package-Type: udeb
+Depends: libklibc-udeb (= ${binary:Version}), ${misc:Depends}
 Description: small utilities built with klibc for the boot floppy
  This package contains a small collection of programs that are linked
  against klibc. These duplicate some of the functionality of a
@@ -64,15 +65,15 @@
  full-function counterparts.  They are intended for inclusion in
  boot floppies.
 
-
 Package: libklibc-udeb
 Section: debian-installer
 Architecture: any
-XC-Package-Type: udeb
-Description: minimal libc subset for use with initramfs
+Package-Type: udeb
+Depends: ${misc:Depends}
+Description: minimal libc subset for use with initramfs (d-i)
  klibc is intended to be a minimalistic libc subset for use with
  initramfs.  It is deliberately written for small size, minimal
  entanglement, and portability, not speed.  It is definitely a work in
  progress, and a lot of things are still missing.
-
-
+ .
+ This is the package for the Debian Installer.

## klibc 2.0.3

=== Makefile ===
--- 
+++ 
@@ -30,7 +30,11 @@
 
 NOSTDINC_FLAGS := -nostdlib -nostdinc -isystem $(shell $(CC) -print-file-name=include)
 
-ARCH	          := $(shell uname -m | sed -e s/i.86/i386/ -e s/parisc64/parisc/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/ -e s/sh.*/sh/)
+ARCH	          := $(shell uname -m | sed -e s/i.86/i386/ \
+			-e s/parisc64/parisc/ -e s/sun4u/sparc64/ \
+			-e s/arm.*/arm/ -e s/sa110/arm/ \
+			-e s/aarch64.*/arm64/ -e s/sh.*/sh/ \
+			-e s/ppc64le/ppc64/)
 export KLIBCARCH  ?= $(ARCH)
 export KLIBCARCHDIR := $(shell echo $(KLIBCARCH) | sed -e s/s390x/s390/)
 
@@ -133,9 +137,10 @@
 	@echo	'KLIBCKERNELSRC - Path to a configured linux tree'
 	@echo	'KLIBCKERNELOBJ - Path to kernel output dir (defaults to KLIBCKERNELSRC)'
 	@echo	'make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
+	@echo	'make V=2   [targets] 2 => give reason for rebuild of target'
 	@echo
 	@echo	'Sample invocation:'
-	@echo	'make  KLIBCKERNELSRC=`pwd`/../linux'
+	@echo	'make  KLIBCKERNELSRC=`pwd`/../linux/usr/'
 
 ###
 # allow one to say make dir/file.o

=== debian/changelog ===
klibc (2.0.3-0ubuntu1) trusty; urgency=medium

  * New upstream release, with ppc64el and arm64 support (LP: #1263793)
    - aarch64-support*: Slightly different and better patches went upstream.
    - 0001-klibc-ppc64-Add-ppc64le-support.patch: Dropped, applied upstream.

 -- Adam Conrad <adconrad@ubuntu.com>  Mon, 23 Dec 2013 18:06:02 -0700

klibc (2.0.2-1ubuntu2) trusty; urgency=low

  * Call dh_auto_clean with $(DEB_MAKE_ENVVARS) to pass ARCH to make.

 -- Adam Conrad <adconrad@ubuntu.com>  Sun, 15 Dec 2013 22:17:46 -0700

klibc (2.0.2-1ubuntu1) trusty; urgency=low

  * Merge with Debian; remaining changes:
    - Apply patches to add support for AArch64.
  * Add PowerPC 64bit little endian support.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Dec 2013 11:33:13 +0100

klibc (2.0.1-3.1ubuntu2) saucy; urgency=low

  * Apply patches to add support for AArch64.

 -- dann frazier <dann.frazier@canonical.com>  Thu, 15 Aug 2013 11:30:54 -0600

klibc (2.0.1-3.1ubuntu1) raring; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - Apply patch from upstream to fix compiling with 3.5 headers.
    - Fix <sys/time.h> for Linux 3.5.1.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 28 Nov 2012 18:04:43 +0000

klibc (2.0.1-3ubuntu1) raring; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - Apply patch from upstream to fix compiling with 3.5 headers.
    - Fix <sys/time.h> for Linux 3.5.1.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 29 Oct 2012 10:32:06 +0000

klibc (2.0.1-1ubuntu2) quantal; urgency=low

  * Fix <sys/time.h> for Linux 3.5.1.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 25 Sep 2012 13:49:22 +0100

klibc (2.0.1-1ubuntu1) quantal; urgency=low

  * Apply patch from upstream to fix compiling with 3.5 headers.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 29 Jun 2012 00:33:11 -0600

=== debian/rules ===
--- 
+++ 
@@ -36,6 +36,9 @@
 ifeq ($(DEB_HOST_ARCH),ppc64)
 DEB_MAKE_ENVVARS := ARCH=ppc64
 endif
+ifeq ($(DEB_HOST_ARCH),ppc64el)
+DEB_MAKE_ENVVARS := ARCH=ppc64
+endif
 
 DEB_MAKE_ENVVARS := INSTALLROOT=debian/tmp $(DEB_MAKE_ENVVARS)
 
@@ -72,7 +75,7 @@
 
 override_dh_auto_clean:
 	rm -rf linux
-	dh_auto_clean
+	dh_auto_clean -- $(DEB_MAKE_ENVVARS)
 
 override_dh_auto_install:
 	make install $(DEB_MAKE_ENVVARS)

=== debian/watch ===
version=3
http://www.kernel.org/pub/linux/libs/klibc/2.0/klibc-([0-9.]+).tar.bz2
